
/////////////////////////////////////////////////////////////
//
// Source file for VideoOptionsFormUI
//
//    This class implements the user interface created in 
//    the interface builder. Normally it is not used directly.
//    Instead the subclass, VideoOptionsForm is instantiated
//
//    To extend or alter the behavior of this class, you should
//    modify the VideoOptionsForm files
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow the builder to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "VideoOptionsFormUI.h" // Generated header file for this class

#include <Xm/Form.h> 
#include <Xm/Label.h> 
#include <Xm/PushB.h> 
#include <Xm/Scale.h> 
#include <Xm/TextF.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  VideoOptionsFormUI::_defaultVideoOptionsFormUIResources[] = {
        "*tabLabel:  Video",
        "*videoPanelButton.labelString:  Video Panel",
        "*fpsDefaultButton.labelString:  Default",
        "*scale.titleString:  Frame rate",
        "*recOffToggle.labelString:  receive Off",
        "*label6.labelString:  Compression:",
        (char*)NULL
};

VideoOptionsFormUI::VideoOptionsFormUI(const char *name) : VkComponent(name) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: VideoOptionsForm constructor 2


    //---- End editable code block: VideoOptionsForm constructor 2


} // End Constructor




VideoOptionsFormUI::VideoOptionsFormUI(const char *name, Widget parent) : VkComponent(name) 
{ 
    // Call creation function to build the widget tree.

     create(parent);

    //---- Start editable code block: VideoOptionsForm constructor


    //---- End editable code block: VideoOptionsForm constructor


} // End Constructor


VideoOptionsFormUI::~VideoOptionsFormUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: VideoOptionsFormUI destructor


    //---- End editable code block: VideoOptionsFormUI destructor
} // End destructor



void VideoOptionsFormUI::create ( Widget parent )
{
    Arg      args[15];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources(parent, _defaultVideoOptionsFormUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _videoOptionsForm = XtVaCreateWidget ( _name,
                                                         xmFormWidgetClass,
                                                         parent, 
                                                         XmNresizePolicy, XmRESIZE_GROW, 
                                                         (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _videoPanelButton = XtVaCreateManagedWidget  ( "videoPanelButton",
                                                    xmPushButtonWidgetClass,
                                                    _baseWidget, 
                                                    XmNlabelType, XmSTRING, 
                                                    XmNrecomputeSize, False, 
                                                    XmNtopAttachment, XmATTACH_FORM, 
                                                    XmNbottomAttachment, XmATTACH_NONE, 
                                                    XmNleftAttachment, XmATTACH_FORM, 
                                                    XmNrightAttachment, XmATTACH_NONE, 
                                                    XmNtopOffset, 195, 
                                                    XmNbottomOffset, 0, 
                                                    XmNleftOffset, 85, 
                                                    XmNrightOffset, 0, 
                                                    XmNwidth, 115, 
                                                    XmNheight, 50, 
                                                    (XtPointer) NULL ); 

    XtAddCallback ( _videoPanelButton,
                    XmNactivateCallback,
                    &VideoOptionsFormUI::videoPanelCallback,
                    (XtPointer) this ); 


    _fpsDefaultButton = XtVaCreateManagedWidget  ( "fpsDefaultButton",
                                                    xmPushButtonWidgetClass,
                                                    _baseWidget, 
                                                    XmNlabelType, XmSTRING, 
                                                    XmNtopAttachment, XmATTACH_FORM, 
                                                    XmNbottomAttachment, XmATTACH_NONE, 
                                                    XmNleftAttachment, XmATTACH_FORM, 
                                                    XmNrightAttachment, XmATTACH_NONE, 
                                                    XmNtopOffset, 145, 
                                                    XmNbottomOffset, 0, 
                                                    XmNleftOffset, 195, 
                                                    XmNrightOffset, 0, 
                                                    XmNwidth, 65, 
                                                    XmNheight, 35, 
                                                    (XtPointer) NULL ); 

    XtAddCallback ( _fpsDefaultButton,
                    XmNactivateCallback,
                    &VideoOptionsFormUI::fpsDefaultCallback,
                    (XtPointer) this ); 


    _scale = XtVaCreateManagedWidget  ( "scale",
                                         xmScaleWidgetClass,
                                         _baseWidget, 
                                         XmNslidingMode, XmSLIDER, 
                                         SgNslanted, False, 
                                         XmNorientation, XmHORIZONTAL, 
                                         XmNshowValue, True, 
                                         XmNtopAttachment, XmATTACH_FORM, 
                                         XmNbottomAttachment, XmATTACH_NONE, 
                                         XmNleftAttachment, XmATTACH_FORM, 
                                         XmNrightAttachment, XmATTACH_NONE, 
                                         XmNtopOffset, 95, 
                                         XmNbottomOffset, 0, 
                                         XmNleftOffset, 20, 
                                         XmNrightOffset, 0, 
                                         XmNwidth, 240, 
                                         XmNheight, 65, 
                                         (XtPointer) NULL ); 


    _recOffToggle = XtVaCreateManagedWidget  ( "recOffToggle",
                                                xmToggleButtonWidgetClass,
                                                _baseWidget, 
                                                XmNalignment, XmALIGNMENT_BEGINNING, 
                                                XmNlabelType, XmSTRING, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 70, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 90, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 100, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 


    _videoCompressionText = XtVaCreateManagedWidget  ( "videoCompressionText",
                                                        xmTextFieldWidgetClass,
                                                        _baseWidget, 
                                                        XmNeditable, False, 
                                                        XmNtopAttachment, XmATTACH_FORM, 
                                                        XmNbottomAttachment, XmATTACH_NONE, 
                                                        XmNleftAttachment, XmATTACH_FORM, 
                                                        XmNrightAttachment, XmATTACH_NONE, 
                                                        XmNtopOffset, 25, 
                                                        XmNbottomOffset, 0, 
                                                        XmNleftOffset, 145, 
                                                        XmNrightOffset, 0, 
                                                        XmNwidth, 105, 
                                                        XmNheight, 30, 
                                                        (XtPointer) NULL ); 
    XtVaSetValues ( _videoCompressionText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _videoCompressionText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label6 = XtVaCreateManagedWidget  ( "label6",
                                          xmLabelWidgetClass,
                                          _baseWidget, 
                                          XmNlabelType, XmSTRING, 
                                          XmNtopAttachment, XmATTACH_FORM, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_FORM, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopOffset, 30, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 30, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 105, 
                                          XmNheight, 20, 
                                          (XtPointer) NULL ); 


    //---- Start editable code block: VideoOptionsFormUI create


    //---- End editable code block: VideoOptionsFormUI create
}

const char * VideoOptionsFormUI::className()
{
    return ("VideoOptionsFormUI");
} // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are static member functions used to 
// interface with Motif.
/////////////////////////////////// 

void VideoOptionsFormUI::fpsDefaultCallback ( Widget    w,
                                              XtPointer clientData,
                                              XtPointer callData ) 
{ 
    VideoOptionsFormUI* obj = ( VideoOptionsFormUI * ) clientData;
    obj->fpsDefault ( w, callData );
}

void VideoOptionsFormUI::videoPanelCallback ( Widget    w,
                                              XtPointer clientData,
                                              XtPointer callData ) 
{ 
    VideoOptionsFormUI* obj = ( VideoOptionsFormUI * ) clientData;
    obj->videoPanel ( w, callData );
}



/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 

void VideoOptionsFormUI::fpsDefault ( Widget, XtPointer ) 
{
    // This virtual function is called from fpsDefaultCallback.
    // This function is normally overriden by a derived class.

}

void VideoOptionsFormUI::videoPanel ( Widget, XtPointer ) 
{
    // This virtual function is called from videoPanelCallback.
    // This function is normally overriden by a derived class.

}



